#!/usr/bin/env python
import sys
import subprocess as sub
import os
import string,re
try:
  from optparse import OptionParser
  from os.path import join as pjoin
except ImportError, e:
  print 'Standard modules missing', e
  sys.exit(1)

import bibtexparse


def main():

  usage = "usage: %prog [options] bibfile1 bibfile2 ..."
  parser = OptionParser(usage=usage)

#   parser.add_option("-i", "--input-file",
#                     help="BibTeX input FILE. REQUIRED Here or as argument", metavar="FILE", default="")

  parser.add_option("-o", "--output-file",
                    help="html output FILE. Default: bib-<author>.html", metavar="FILE", default=None)

  parser.add_option("-P", "--output-path",
                    help="Where to copy the Output FILE. Default: default (current path)", metavar="FILE", default='./')

  parser.add_option("-a", "--author",
                    help="Author to look for.", default='fiol')

  parser.add_option("-x", "--xslt",
                    help="Program for xslt processing.", default='xsltproc')
  parser.add_option("-s", "--stylesheet",
                    help="Stylesheet for the conversion xml -> html.", default='example_year.xsl')

  (op, args) = parser.parse_args()


  if len(args)== 0:
    parser.print_help()
    sys.exit(2)


  if not op.output_file:
    op.output_file= 'bib-' + op.author.lower() + '.html'

  output_file= pjoin(op.output_path, op.output_file)

  input_file=""
  for fil in args:
    input_file += fil + ' '
  input_file= input_file.strip()
  
########################################################################
  rootname= 'bib-'+ op.author.lower()
  xmlref = 'ref-'+rootname + '.xml'
  xmlnref= 'nref-'+rootname + '.xml'
  htmlbib= rootname + '.html'
  
  biblist= bibtexparse.bibteximport(input_file)

  auth_options= [('author', op.author , True)
                 ]
  nref_options= [ ('type', 'thesis', True)
                 ]
  ref_options= [ ('type', 'thesis', False),
                 ]
  # First keep only authors
  biblist= bibtexparse.filter_bib(biblist, auth_options)
  
  # Make to xml files with ref and non-refereed entries
  nrefbib= bibtexparse.filter_bib(biblist, nref_options)
  refbib = bibtexparse.filter_bib(biblist, ref_options)

  # Convert the to xml and Write them to files
  p1= bibtexparse.bibtex_to_xml(nrefbib)
  p2= bibtexparse.bibtex_to_xml(refbib)

  f1=open(xmlnref,'w')
  f1.write(p1)
  f1.close()
  f1=open(xmlref,'w')
  f1.write(p2)
  f1.close()

  # Convert to HTML
  s= '<h2>Refereed Publications</h2>\n'
  os.system(op.xslt + ' ' + op.stylesheet + ' ' + xmlref + '> '+ htmlbib)
  f=open(htmlbib,'r')
  s+=f.read()
  f.close()

  s+= '<h2>Non-refereed Publications</h2>\n'
  os.system(op.xslt + ' ' + op.stylesheet + ' ' + xmlnref + '> ' + htmlbib)
  f=open(htmlbib,'r')
  s+=f.read()
  f.close()
  

  

  fo=open(output_file,'w')
  fo.write(s)
  fo.close()

if __name__ == "__main__":
  main()


### Local Variables: 
### tab-width: 2
### END:

